ASN1UTCTime (Bouncy Castle Library 1.85 API Specification)
Date: 2026-07-12

org.bouncycastle.asn1

## Class ASN1UTCTime

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.ASN1Primitive
    - - org.bouncycastle.asn1.ASN1UTCTime

- All Implemented Interfaces:
    ASN1Encodable, Encodable
  Direct Known Subclasses:
    DERUTCTime

      public class ASN1UTCTime
      extends ASN1Primitive

  - * UTC time object. Internal facade of `ASN1UTCTime`.

  This datatype is valid only from 1950-01-01 00:00:00 UTC until 2049-12-31 23:59:59 UTC.

  X.690

  11: Restrictions on BER employed by both CER and DER

  11.8 UTCTime

  11.8.1 The encoding shall terminate with "Z", as described in the ITU-T X.680 | ISO/IEC 8824-1 clause on UTCTime.

  11.8.2 The seconds element shall always be present.

  11.8.3 Midnight (GMT) shall be represented in the form:

  > "YYMMDD000000Z"

  where "YYMMDD" represents the day following the midnight in question.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ASN1UTCTime(java.util.Date time)` Base constructor from a java.util.date object
    `ASN1UTCTime(java.util.Date time, java.util.Locale locale)` Base constructor from a `Date` and an explicit `Locale`.
    `ASN1UTCTime(java.lang.String time)` The correct format for this is YYMMDDHHMMSSZ (it used to be that seconds were never encoded.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Date` | `getAdjustedDate()` Return the time as an adjusted date in the range of 1950 - 2049.
    `java.lang.String` | `getAdjustedTime()` Return a time string as an adjusted date with a 4 digit year.
    `java.util.Date` | `getDate()` Return the time as a date based on whatever a 2 digit year will return.
    `static ASN1UTCTime` | `getInstance(ASN1TaggedObject taggedObject, boolean declaredExplicit)` Return an UTC Time from a tagged object.
    `static ASN1UTCTime` | `getInstance(java.lang.Object obj)` Return an UTC Time from the passed in object.
    `static ASN1UTCTime` | `getTagged(ASN1TaggedObject taggedObject, boolean declaredExplicit)`
    `java.lang.String` | `getTime()` Return the time - always in the form of YYMMDDhhmmssGMT(+hh:mm|-hh:mm).
    `int` | `hashCode()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Primitive

      `encodeTo, encodeTo, equals, equals, equals, fromByteArray, fromStream, toASN1Primitive`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `getEncoded, getEncoded, hasEncodedTagValue`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ASN1UTCTime

          public ASN1UTCTime(java.lang.String time)

      The correct format for this is YYMMDDHHMMSSZ (it used to be that seconds were never encoded. When you're creating one of these objects from scratch, that's what you want to use, otherwise we'll try to deal with whatever gets read from the input stream... (this is why the input format is different from the getTime() method output).

      Parameters:
        `time` - the time string.

    - #### ASN1UTCTime

          public ASN1UTCTime(java.util.Date time)

      Base constructor from a java.util.date object
      Parameters:
        `time` - the Date to build the time from.

    - #### ASN1UTCTime

          public ASN1UTCTime(java.util.Date time,
                             java.util.Locale locale)

      Base constructor from a `Date` and an explicit `Locale`. The `locale` selects the calendar used by the underlying `SimpleDateFormat`. Most callers should prefer the simple `ASN1UTCTime(Date)` form, which always formats under an English Gregorian locale (so the encoded year is the spec-mandated Gregorian one regardless of `Locale.getDefault()`, including on JVMs whose default uses a non-Gregorian calendar such as Thai Buddhist `th_TH_TH_#u-nu-thai` or Japanese Imperial `ja_JP_JP_#u-ca-japanese`). Reach for this `(Date, Locale)` form only when you need explicit control over the formatter's calendar.
      Parameters:
        `time` - a date object representing the time of interest.
        `locale` - the Locale whose calendar the underlying SimpleDateFormat should use.

  - ### Method Detail

    - #### getInstance

          public static ASN1UTCTime getInstance(java.lang.Object obj)

      Return an UTC Time from the passed in object.
      Parameters:
        `obj` - an ASN1UTCTime or an object that can be converted into one.
      Returns:
        an ASN1UTCTime instance, or null.
      Throws:
        `java.lang.IllegalArgumentException` - if the object cannot be converted.

    - #### getInstance

          public static ASN1UTCTime getInstance(ASN1TaggedObject taggedObject,
                                                boolean declaredExplicit)

      Return an UTC Time from a tagged object.
      Parameters:
        `taggedObject` - the tagged object holding the object we want
        `declaredExplicit` - true if the object is meant to be explicitly tagged false otherwise.
      Returns:
        an ASN1UTCTime instance, or null.
      Throws:
        `java.lang.IllegalArgumentException` - if the tagged object cannot be converted.

    - #### getTagged

          public static ASN1UTCTime getTagged(ASN1TaggedObject taggedObject,
                                              boolean declaredExplicit)

    - #### getDate

          public java.util.Date getDate()
                                 throws java.text.ParseException

      Return the time as a date based on whatever a 2 digit year will return. For standardised processing use getAdjustedDate().
      Returns:
        the resulting date
      Throws:
        `java.text.ParseException` - if the date string cannot be parsed.

    - #### getAdjustedDate

          public java.util.Date getAdjustedDate()
                                         throws java.text.ParseException

      Return the time as an adjusted date in the range of 1950 - 2049.
      Returns:
        a date in the range of 1950 to 2049.
      Throws:
        `java.text.ParseException` - if the date string cannot be parsed.

    - #### getTime

          public java.lang.String getTime()

      Return the time - always in the form of YYMMDDhhmmssGMT(+hh:mm|-hh:mm).

      Normally in a certificate we would expect "Z" rather than "GMT", however adding the "GMT" means we can just use:

               dateF = new SimpleDateFormat("yyMMddHHmmssz");

      To read in the time and get a date which is compatible with our local time zone.

      Note: In some cases, due to the local date processing, this may lead to unexpected results. If you want to stick the normal convention of 1950 to 2049 use the getAdjustedTime() method.

    - #### getAdjustedTime

          public java.lang.String getAdjustedTime()

      Return a time string as an adjusted date with a 4 digit year. This goes in the range of 1950 - 2049.

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `ASN1Primitive`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`